
datablock AudioProfile(HerculesidleSound)
{
   filename    = "./idled.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};


datablock AudioProfile(Herculesthrottle1Sound)
{
   filename    = "./1.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};








datablock ExplosionData(HerculesFinalExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = vehicleExplosionSound;
   
   emitter[0] = vehicleFinalExplosionEmitter3;
   emitter[1] = vehicleFinalExplosionEmitter2;

   particleEmitter = vehicleFinalExplosionEmitter;
   particleDensity = 20;
   particleRadius = 1.0;

   //debris = FlyingShapedebris;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 20;
   debrisVelocity = 18;
   debrisVelocityVariance = 3;
   
   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 0.75;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 20;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 15;
   impulseForce = 1000;
   impulseVertical = 2000;

   //radius damage
   damageRadius = 17;
   radiusDamage = 100;

   //burn the players?
   playerBurnTime = 5000;

};
datablock ProjectileData(HerculesFinalExplosionProjectile)
{
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 0;
   explosion           = HerculesFinalExplosion;

   directDamageType  = $DamageType::jeepExplosion;
   radiusDamageType  = $DamageType::jeepExplosion;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 10;
};
datablock WheeledVehicleData(HerculesVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./c130e.dts";



	emap = true;
	minMountDist = 3;
   
   numMountPoints = 7;
   mountThread[0] = "sit";
   mountThread[1] = "root";
   mountThread[2] = "root";
   mountThread[3] = "root";
   mountThread[4] = "root";
   mountThread[5] = "root";
   mountThread[6] = "root";









	maxDamage = 100.00;
	destroyedLevel = 200.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";
   //massBox = "2 5 1";

	maxSteeringAngle = 1;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 40;         // Far distance from vehicle
	cameraOffset = 3;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.0;//exec("add-ons/vehicle_Hercules/vehicle_Hercules.cs");
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = true;	

	// defaultTire	= HerculesTire;
	// defaultSpring	= HerculesSpring;
	// flatTire	= HerculesFlatTire;
	// flatSpring	= HerculesFlatSpring;

   numWheels = 7;

	// Rigid Body
	mass = 200;
	density = 5.0;
	drag = 0.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 600; //4000;       // Engine power
	engineBrake = 0;         // Braking when throttle is 0
	brakeTorque = 1000;        // When brakes are applied
	maxWheelSpeed = 20;        // Engine scale by current speed / max speed


	rotationalDrag		= 0.2;

	// Energy
	maxEnergy = 100;
	jetForce = 6000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

   isSled = false;

   forwardThrust		= 2000;
	reverseThrust		= 20;
	lift			= 20;
	maxForwardVel		= 70;
	maxReverseVel		= 20;
	horizontalSurfaceForce	= 130;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 130; 
	rollForce		= 20000;
	yawForce		= 20000;
	pitchForce		= 20000;
	rotationalDrag		= 0.5;
	stallSpeed		= 10;



	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "C-130 Hercules";
	rideable = true;
		lookUpLimit = 0.50;
		lookDownLimit = 0.50;

	paintable = true;
   
   damageEmitter[0] = LightDamageEmitter; 
   	damageEmitterOffset[0] = "0.0 3.0 1.0 ";
	damageLevelTolerance[0] = 0.35;
		
	
		damageEmitter[1] = HeavyDamageEmitter; 
	damageEmitterOffset[1] = "0.0 3.0 0.0 ";
	damageLevelTolerance[1] = 0.7;
	
	
   damageEmitter[2] = VehicleBurnEmitter;
	damageEmitterOffset[2] = "0.0 0.0 0.0 ";
	damageLevelTolerance[2] = 0.99;

   damageEmitter[3] = VehicleBurnEmitter;
	damageEmitterOffset[3] = "0.0 0.0 0.0 ";
	damageLevelTolerance[3] = 1.0;

   numDmgEmitterAreas = 1;
   initialExplosionProjectile = jeepExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = HerculesFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed
      minHerculesSpeed = 20;
      // Advanced Steering   minHerculesSpeed = 20;
   steeringAutoReturn = false;
   // steeringAutoReturnRate = 0.9;
   // steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = false;
   // steeringStrafeSteeringRate = 0.1;
   
   // minContrailSpeed = 30;
};



function Herculesvehicle::onadd(%this,%obj)
{ 
	parent::onadd(%this,%obj);
		
	%obj.setWheelTire(0, Herculestire);
	%obj.setWheelTire(1, Herculestire);
	%obj.setWheelTire(2, Herculestire);
	%obj.setWheelTire(3, Herculestire);
	%obj.setWheelTire(4, Herculestire);
	%obj.setWheelTire(5, Herculestire);



	
HerculesSpeedCheck(%this, %obj);
	%obj.setWheelSpring(0, HerculesSpring);
	%obj.setWheelSpring(1, HerculesSpring);
	%obj.setWheelSpring(2, HerculesSpring);
	%obj.setWheelSpring(3, HerculesSpring);
	%obj.setWheelSpring(4, HerculesSpring);
	%obj.setWheelSpring(5, HerculesSpring);


	
	%obj.setWheelSteering(0,1);
	%obj.setWheelSteering(1,0);
	%obj.setWheelSteering(2,0);
	%obj.setWheelSteering(3,0);
	%obj.setWheelSteering(4,0);
	%obj.setWheelSteering(5,0);


	%obj.setWheelPowered(0,true);
    %obj.setWheelPowered(1,true);
	%obj.setWheelPowered(2,true);
	%obj.setWheelPowered(3,true);
    %obj.setWheelPowered(4,true);
	%obj.setWheelPowered(5,true);

	
	
	%obj.playthread(1,spin);
	

}
datablock ShapeBaseImageData(JeepCargoImage)
{
   shapeFile = "add-ons/vehicle_jeep/jeep.dts";
	emap = false;

	mountPoint = 11;
};
datablock WheeledVehicleSpring(HerculesSpring)
{
   // Wheel suspension properties
   length = 0.4;			 // Suspension travel
   force = 3000; //3000;		 // Spring force
   damping = 400; //600;		 // Spring damping
   antiSwayForce = 3; //3;		 // Lateral anti-sway force
};




///////////////////////////////////////////////////////////////

datablock WheeledVehicleTire(HerculesTire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "add-ons/vehicle_jeep/jeeptire.dts";
	
	mass = 10;
    radius = 1;
    staticFriction = 5;
   kineticFriction = 5;
   restitution = 0.5;	

   // Spring that generates lateral tire forces
   lateralForce = 18000;
   lateralDamping = 4000;
   lateralRelaxation = 0.01;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 14000;
   longitudinalDamping = 2000;
   longitudinalRelaxation = 0.01;
};


function HerculesVehicle::onImpact(%this,%obj,%data)
{
	%speed = vectorLen(%obj.getVelocity());
	if(%speed > %obj.dataBlock.minHerculesSpeed)

		%trans = %obj.getTransform();

	%p = new Projectile()
	{
		dataBlock = jeepFinalExplosionProjectile;
		initialVelocity  = "0 0 0";
		initialPosition  = %trans;
		sourceObject     = %obj;
		sourceSlot       = 0;
		client           = %obj.client;
	};
	MissionCleanup.add(%p);
	         if(%obj.destroyed)
            return;
         %obj.setDamageLevel(%this.maxDamage);
         %obj.destroyed = 1;
         %obj.schedule(10,"finalExplosion");
         if(isObject(%obj.spawnBrick.client.minigame))
            %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
         %obj.spawnBrick.schedule(%respawn,"spawnVehicle");

	
}


function HerculesSpeedCheck(%this, %obj)
{


	if(!isObject(%obj))
		return;

	%vehicle = %obj;
%slot = 0; //Play the sound in the driver's spot
	%speed = vectorLen(%obj.getVelocity());

	if(%speed < 0) //Keeps throwing random negative numbers when train is at dead stop
	    %speed = 0;

	if(%speed < 10)
	    %vehicle.playAudio(%slot, HerculesidleSound);

	else if(%speed < 30)
	    %vehicle.playAudio(%slot, Herculesthrottle1Sound);

			//%obj.playThread(0,spin);


	    

	schedule(500,0,"HerculesSpeedCheck",%this,%obj);
}

function HerculesVehicle::onTrigger(%this, %obj, %num, %cli, %wha)
{

}

